#ifndef CL_COMPILE

#pragma once

#endif

typedef struct tag_scc_value {
    cl_uint value_num;
    cl_uint value_den;
} scc_value;

typedef struct tag_scc_interval {
    cl_uint value_lower_num;
    cl_uint value_lower_den;
    cl_uint value_upper_num;
    cl_uint value_upper_den;
} scc_interval;

#define HASH(a,b,h)        ((a + 29496751 * b) % h)

#ifndef CL_COMPILE

BOOST_COMPUTE_ADAPT_STRUCT(scc_value, scc_value, (
    value_num, value_den
))

BOOST_COMPUTE_ADAPT_STRUCT(scc_interval, scc_interval, (
    value_lower_num, value_lower_den, value_upper_num, value_upper_den
))

#endif
